import { world, Player, EntityDamageCause } from "@minecraft/server";

world.afterEvents.projectileHitEntity.subscribe((data) => {
    const { projectile, source: player } = data;
    if (!(player instanceof Player)) return;

    const hit = data.getEntityHit().entity
    const bullet = ag.bullets[projectile.typeId.replace("agbullet:", "")];

    hit.applyDamage(bullet.damage, {
        cause: EntityDamageCause.override,
        damagingProjectile: projectile,
        damagingEntity: player
    });

});


world.afterEvents.entityDie.subscribe((ev) => {
    const { damageSource, deadEntity } = ev

    const cause = damageSource.cause
    const killer = damageSource.damagingEntity

    if (cause == EntityDamageCause.override && deadEntity.typeId == "minecraft:player") {
        const deathMessage = `death.attack.customBullet`

        world.sendMessage({ translate: deathMessage, "with": [deadEntity.nameTag, killer.nameTag] })

    }
})